﻿using Styx;
using Styx.Common;
using Styx.CommonBot;
using Styx.Plugins;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Media;
using P = FishingBaits.BaitSettings;

namespace FishingBaits
{
    public class BaitMain : HBPlugin
    {
        public override string Name { get { return "Apply WoD Fishing Baits"; } }
        public override string Author { get { return "Pasterke"; } }
        public override bool WantButton { get { return true; } }
        public override Version Version { get { return _version; } }
        private readonly Version _version = new Version(1, 0);
        public override string ButtonText { get { return "Show Settings"; } }
        private static string usedBot { get { return BotManager.Current.Name.ToUpper(); } }
        private static int _baitBuff { get { return P.myPrefs.BaitBuff; } }
        private static int BaitToUse { get { return P.myPrefs.useBait; } }
        private static int WormSupremeID = 118391;
        private static DateTime applyLure;

        public override void OnEnable()
        {
            Logging.Write(Colors.Yellow, "Thanks {0} for using Fishing Baits", StyxWoW.Me.Name);
            Logging.Write(Colors.CornflowerBlue, "By Pasterke");
        }

        public override void OnDisable()
        {
            Logging.Write(Colors.Yellow, "Hope {0}, you liked to use Pasterke's plugin", StyxWoW.Me.Name);
        }

        public override void OnButtonPress()
        {
            new BaitGUI().ShowDialog();
        }

        public override void Pulse()
        {
            if (!StyxWoW.Me.Combat
                && !StyxWoW.Me.IsMoving
                && usedBot.Contains("ANGLER")
                && BaitToUse != 0
                && !StyxWoW.Me.HasAura(_baitBuff)
                && HaveFishingRod)
            {
                CheckAndApplyBuffs(BaitToUse);
            }
            return;
        }


        private static DateTime baitChecker;
        private static string BaitMsg = string.Empty;
        private static int BaitBuff { get; set; }

        private static void CheckAndApplyBuffs(int itemID)
        {
            if (itemID == 110293) BaitMsg = "Applying: Abyssal Gulper Eel Bait"; BaitBuff = 158038;
            if (itemID == 110290) BaitMsg = "Applying: Blind Lake Surgeon Bait"; BaitBuff = 158035;
            if (itemID == 110292) BaitMsg = "Applying: Sea Scorpion Bait"; BaitBuff = 158037;
            if (itemID == 110274) BaitMsg = "Applying: Jawless Sulker Bait"; BaitBuff = 158031;
            if (itemID == 110294) BaitMsg = "Applying: Blackwater Whiptail Bait"; BaitBuff = 158039;
            if (itemID == 110291) BaitMsg = "Applying: Fire Ammonite Bait"; BaitBuff = 158036;
            if (itemID == 110289) BaitMsg = "Applying: Fat Sleeper Bait"; BaitBuff = 158034;

            if (P.myPrefs.WormSupreme && HaveFishingRod && DateTime.Now > applyLure)
            {
                applyWormSupreme();
            }

            if (HaveBaitInBags(itemID) && !StyxWoW.Me.HasAura(BaitBuff) && DateTime.Now > baitChecker)
            {
                WoWItem item = StyxWoW.Me.BagItems.FirstOrDefault(h => h.Entry == itemID);
                Logging.Write(Colors.DeepPink, BaitMsg);
                item.Use();
                baitChecker = DateTime.Now + new TimeSpan(0, 0, 0, 10, 0);
            }
            return;
        }

        private static bool HaveBaitInBags(int itemID)
        {
            WoWItem p = StyxWoW.Me.BagItems.FirstOrDefault(h => h.Entry == itemID);
            return p != null ? true : false;
        }

        private static bool HaveFishingRod
        {
            get
            {
                var mainHand = StyxWoW.Me.Inventory.Equipped.MainHand;
                if (mainHand == null || mainHand.ItemInfo.WeaponClass == WoWItemWeaponClass.FishingPole)
                {
                    return true;
                }
                return false; ;
            }
        }
        private static void applyWormSupreme()
        {
                WoWItem lure = StyxWoW.Me.BagItems.FirstOrDefault(h => h.Entry == WormSupremeID);

                if (lure != null)
                {
                    lure.Use();
                    applyLure = DateTime.Now + new TimeSpan(0, 0, 10, 0, 0);
                }
        }
    }
}
